<?php
/**
 * Récupération des données depuis le LDAP
 */
function get_ldap_infos( $uid ) {

	$ldaphost = "ldap-m2.in.ac-dijon.fr";
	$ldapport = "389";
	$ldapdn = "ou=ac-dijon, ou=education, o=gouv, c=fr";

	//Noms des attributs dans le LDAP
	$ldap_cn = "cn"; //Equivalent du Nom Prenom
	$ldap_mail = "mail"; //Mail
	$ldap_uid = "uid"; //uid ou login

	try{
		$ldapconn = ldap_connect($ldaphost,$ldapport) or die("Impossible de se connecter au serveur LDAP {$ldaphost}");
		$infos_user_ldap = array();
		if($ldapconn){
			$ldapbind = ldap_bind($ldapconn);
	 		if($ldapbind){
	    		$filtre = $ldap_uid."=".$uid;
		        $read = ldap_search($ldapconn,$ldapdn,$filtre);
		        $info = ldap_get_entries($ldapconn,$read);
				if(isset($info[0][$ldap_cn][0])){
		        	 $infos_user_ldap[0] = $info[0][$ldap_cn][0];
		        }
		        if(isset($info[0][$ldap_mail][0])){
		        	$infos_user_ldap[1] = $info[0][$ldap_mail][0];
		        }
	    	}else{
	       		echo 'Connexion LDAP anonmye échouée';
	    	}
		}else{
			echo 'Erreur de connection au serveur LDAP';
		}
		ldap_close($ldapconn);
	}catch(Exception $e){
		echo 'Exception : '.$e->getMessage();
	}
	return $infos_user_ldap;
}


?>